import React from "react";
import { TranslationProps } from "../../i18n";
export interface MultipleValueSelectProps {
    values: any[];
    inputValue: string;
    onChange: (value: any[]) => void;
    onSelect: (value: any[]) => void;
    onCancel: () => void;
    offset: number;
    /**
     * 是否支持全选
     *
     * @default true
     */
    all?: boolean;
}
export interface MultipleValueSelectState {
    curIndex: number;
    select: number[];
}
export declare class MultipleValueSelect extends React.Component<MultipleValueSelectProps & TranslationProps, MultipleValueSelectState> {
    constructor(props: any);
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: MultipleValueSelectProps): void;
    handleKeyDown: (keyCode: number) => boolean;
    getValue(select: Array<number>): Array<any>;
    move: (step: number) => void;
    handleClick: (e: React.MouseEvent<Element, MouseEvent>, index: number) => void;
    handleSelectAll: (e?: React.MouseEvent<Element, MouseEvent>) => void;
    handleSubmit: (e: any) => void;
    handleCancel: (e: any) => void;
    render(): JSX.Element;
}
