/* eslint-disable no-undef */
import React, { Component } from "react";
import { mount } from "enzyme";
// eslint-disable-next-line import/no-extraneous-dependencies
import renderer from "react-test-renderer";
import { ContentView } from "../ContentView";
import { Text } from "../../text";
import { Card } from "../../card";
import { ExternalLink } from "../../link";

describe("Card", () => {
  const contentView = (
    <ContentView>
      <ContentView.Header
        showBackButton
        onBackButtonClick={console.log}
        title="内容标题"
        subtitle={
          <>
            说明文字 <Text theme="label">带颜色说明文字</Text>
          </>
        }
        operation={<ExternalLink weak>内容帮助</ExternalLink>}
      />
      <ContentView.Body>
        {/* 内容区域一般使用 Card 组件显示内容 */}
        <Card>
          <Card.Body>内容卡片</Card.Body>
        </Card>
      </ContentView.Body>
    </ContentView>
  );

  it("render correctly", () => {
    const component = renderer.create(contentView);
    const tree = component.toJSON();
    expect(tree).toMatchSnapshot();
  });
});
