import React from "react";
import moment from "moment";
import { DatePicker } from "@tea/component/datepicker";

const { RangePicker, MonthPicker } = DatePicker;

export default () => {
  return (
    <>
      <section>
        <h3>日期选择 range</h3>
        <DatePicker
          defaultValue={moment("2019-04-01")}
          range={[moment("2019-01-01"), moment("2020-01-11")]}
          onChange={value => console.log(value.format("L"))}
        />
      </section>
      <section>
        <h3>包含时间的日期选择 range</h3>
        <DatePicker
          showTime
          range={[moment("2019-02-02 12:30:00"), moment("2020-02-12 12:30:00")]}
          onChange={value => console.log(value.format())}
        />
      </section>
      <section>
        <h3>月份选择 range</h3>
        <MonthPicker
          defaultValue={moment("2019-04-01")}
          range={[moment("2018-09"), moment("2020-01")]}
          onChange={value => console.log(value.format("L"))}
        />
      </section>
      <section>
        <h3>包含时间的范围选择 range</h3>
        <RangePicker
          range={[
            moment()
              .subtract(6, "d")
              .startOf("d"),
            moment().endOf("d"),
          ]}
          defaultValue={[
            moment()
              .subtract(6, "d")
              .startOf("d"),
            moment().endOf("d"),
          ]}
          showTime={{
            defaultValue: [
              moment("00:00:00", "HH:mm:ss"),
              moment("23:59:59", "HH:mm:ss"),
            ],
          }}
          onChange={value => console.log(value[0].format(), value[1].format())}
        />
      </section>
    </>
  );
};
