import React from "react";
import { Layout } from "@tea/component/layout";
import { Card } from "@tea/component/card";
import { ExternalLink } from "@tea/component/link";
import {
  RegionSelect,
  RegionPanel,
  RegionOption,
} from "@tea/component/regionselect";

const { Body, Content } = Layout;

function LayoutContentExample() {
  return (
    <Layout>
      <Body>
        <Content>
          <Content.Header
            showBackButton
            onBackButtonClick={console.log}
            title="内容标题"
            operation={<ExternalLink weak>内容帮助</ExternalLink>}
          >
            <RegionSelect value="all">
              <RegionPanel>
                <RegionPanel.Head>
                  <RegionOption value="all" flag="Globe">
                    全部地域 (1108)
                  </RegionOption>
                </RegionPanel.Head>
                <RegionPanel.Column>
                  <RegionPanel.Group name="中国大陆">
                    <RegionOption value="gz" flag="China">
                      广州 (20)
                    </RegionOption>
                    <RegionOption value="sh" flag="China" dot>
                      上海 (20)
                    </RegionOption>
                  </RegionPanel.Group>
                </RegionPanel.Column>
              </RegionPanel>
            </RegionSelect>
          </Content.Header>
          <Content.Body>
            {/* 内容区域一般使用 Card 组件显示内容 */}
            <Card>
              <Card.Body>内容卡片</Card.Body>
            </Card>
          </Content.Body>
          <Content.Footer>
            <div className="layout-footer-demo">
              (可选项)自定义页脚
              <br />
              京公网安备 11010802017518 粤B2-20090059-1
            </div>
          </Content.Footer>
        </Content>
      </Body>
    </Layout>
  );
}

export default function Demo() {
  return (
    <section
      style={{
        height: 360,
        border: "1px solid #ddd",
      }}
    >
      <LayoutContentExample />
    </section>
  );
}
