import React from "react";
import classNames from "classnames";
import { Icon } from "../icon";
import { useTranslation } from "../i18n";
import { StyledProps } from "../_type";

export interface LoadingTipProps extends StyledProps {
  /**
   * 加载文案
   * @default "加载中..."
   */
  loadingText?: React.ReactNode;
}

export function LoadingTip({ className, style, loadingText }: LoadingTipProps) {
  const t = useTranslation();
  const text = loadingText || t.loadingText;
  return (
    <span className={classNames("tea-action-state", className)} style={style}>
      <Icon type="loading" className="tea-mr-2n" />
      {typeof text === "string" ? (
        <span className="tea-action-state__text">{text}</span>
      ) : (
        text
      )}
    </span>
  );
}
