import { NestedArray } from "d3";
import { Context } from "../context";
export interface LegendData {
    label: string;
    color: string;
    index: number;
    key: string;
    raw: {
        key: string;
        values: NestedArray<{
            [key: string]: string | number;
        }, string> | {
            [key: string]: string | number;
        }[];
        value: string;
    };
}
export declare class Legend {
    /**
     * 上下文
     */
    private ctx;
    /**
     * 图例对象
     */
    private legend;
    /**
     * 不显示的数据系列
     */
    private disabledKeys;
    constructor(ctx: Context);
    private updateLegendData;
    /**
     * 绘制图例
     * @param nestData 结构化数据
     * @param yKey Y 轴映射字段名
     */
    private draw;
    /**
     * 当绘图区渲染完成之后，再定位 Legend 坐标
     */
    private setPosition;
    private onLegendItemHover;
    private onLegendItemLeft;
    private onLegendItemClick;
}
