import { Context } from "../../context";
import { RectCoordinate } from "../../coordinate/rect";
import { Color } from "../../../type";
import { Shape } from "../shape";
export declare class Line extends Shape {
    /**
     * 绑定的坐标实例
     */
    private coordinate;
    /**
     * 折线对象
     */
    private line;
    /**
     * 线的粗细
     */
    private lineWidth;
    constructor(ctx: Context, coordinate: RectCoordinate);
    /**
     * 设置数据映射
     * @param pos 同 chart.position
     */
    position(pos: string): this;
    /**
     * 以颜色来作为数据映射
     * @param color 字段名
     */
    color(color: string | Color): this;
    /**
     * 设置线条的粗细
     * @param size 粗细值
     */
    size(size: number): this;
    /**
     * 设置坐标轴配置
     * @param axis 坐标轴配置
     */
    axis(axis: Context["axis"]): this;
    /**
     * 开始绘图
     *
     * @param highlightIndex 高亮的索引值
     */
    draw(highlightIndex?: number): this;
    /**
     * 绘制辅助点
     */
    private drawHoverPoint;
    /**
     * 显示辅助点
     * @param xPos x 坐标
     * @param index 行索引
     */
    private showHoverPoint;
    /**
     * 隐藏辅助点
     */
    private hideHoverPoint;
    private onLegendItemHover;
    private onLegendItemLeft;
}
