export interface Theme {
    color?: string[] | ((key: string, index: number, isLast: boolean) => string);
    xAxis?: AxisTheme;
    yAxis?: AxisTheme;
    padding?: {
        top?: number;
        left?: number;
        bottom?: number;
        right?: number;
    };
    legend?: {
        height?: number;
        rect?: {
            height: number;
            width: number;
        };
        circle?: {
            radius: number;
        };
        square?: {
            width: number;
        };
        text?: {
            fontSize: number;
            color: string;
            disabledColor: string;
        };
    };
}
export interface AxisTheme {
    axisLine?: {
        lineStyle?: {
            color?: string;
        };
    };
    axisTick?: {
        lineStyle?: {
            color?: string;
        };
    };
    axisLabel?: {
        color?: string;
    };
    splitLine?: {
        show?: boolean;
        lineStyle?: {
            color?: string[];
        };
    };
}
