"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
/**
 * 快速创建 DOM 容器组件
 * @param displayName 组件名称
 * @param paths 组件的容器路径，如 div.tea-card__body
 */
exports.createRocket = function (displayName) {
    var paths = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        paths[_i - 1] = arguments[_i];
    }
    var parentOf = function (children, path) {
        var _a = tslib_1.__read(path.split(".")), tag = _a[0], classNames = _a.slice(1);
        return react_1.default.createElement(tag, {
            className: classNames.join(" "),
        }, children);
    };
    var Rocket = react_1.forwardRef(function (props, ref) {
        var children = props.children, className = props.className, style = props.style;
        var element = paths.reduceRight(parentOf, children);
        if (className || style) {
            var elementProps = element.props;
            element = react_1.default.cloneElement(element, {
                ref: ref,
                className: [elementProps.className, className]
                    .filter(Boolean)
                    .join(" "),
                style: style,
            });
        }
        return element;
    });
    Rocket.displayName = displayName;
    return Rocket;
};
//# sourceMappingURL=create-rocket.js.map