"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var form_1 = require("../form");
var popover_1 = require("../popover");
var input_1 = require("../input");
var icon_1 = require("../icon");
var i18n_1 = require("../i18n");
var CascaderBox_1 = require("./CascaderBox");
var use_default_1 = require("../_util/use-default");
function Cascader(props) {
    var t = i18n_1.useTranslation();
    var _a = form_1.useDefaultValue(props, []), data = _a.data, value = _a.value, onChange = _a.onChange, onLoad = _a.onLoad, disabled = _a.disabled, changeOnSelect = _a.changeOnSelect, className = _a.className, style = _a.style, _b = _a.placeholder, placeholder = _b === void 0 ? t.pleaseSelect : _b, _c = _a.defaultOpen, defaultOpen = _c === void 0 ? false : _c, open = _a.open, _d = _a.onOpenChange, onOpenChange = _d === void 0 ? function () { return null; } : _d, _e = _a.placement, placement = _e === void 0 ? "bottom-start" : _e, _f = _a.placementOffset, placementOffset = _f === void 0 ? 5 : _f, _g = _a.closeOnScroll, closeOnScroll = _g === void 0 ? true : _g;
    var _h = tslib_1.__read(use_default_1.useDefault(open, defaultOpen, onOpenChange), 2), isOpened = _h[0], setIsOpened = _h[1];
    var options = CascaderBox_1.getOptions(data, value);
    return (react_1.default.createElement(popover_1.Popover, { trigger: disabled ? "empty" : "click", visible: isOpened, onVisibleChange: setIsOpened, placement: placement || "bottom-start", placementOffset: placementOffset, closeOnScroll: closeOnScroll, overlay: function (_a) {
            var scheduleUpdate = _a.scheduleUpdate;
            return (react_1.default.createElement(CascaderBox_1.CascaderBox, { data: data, value: value, onChange: onChange, onLoad: onLoad, onClose: function () { return setIsOpened(false); }, changeOnSelect: changeOnSelect, scheduleUpdate: scheduleUpdate }));
        } },
        react_1.default.createElement("div", { className: classnames_1.default("tea-cascader", className), style: style },
            react_1.default.createElement("div", { className: "tea-cascader__input" },
                react_1.default.createElement("div", { className: "tea-cascader__value" }, options.map(function (_a) {
                    var value = _a.value, label = _a.label;
                    return (react_1.default.createElement("span", { key: value, className: "tea-cascader__label" }, label || value));
                })),
                react_1.default.createElement(input_1.Input, { readonly: true, autoComplete: "off", placeholder: value.length ? "" : placeholder })),
            react_1.default.createElement(icon_1.Icon, { type: "arrowdown" }))));
}
exports.Cascader = Cascader;
//# sourceMappingURL=Cascader.js.map