"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var FormItem_1 = require("./FormItem");
var FormControl_1 = require("./FormControl");
var create_rocket_1 = require("../_util/create-rocket");
var FormContext_1 = require("./FormContext");
function Form(_a) {
    var style = _a.style, className = _a.className, children = _a.children, layout = _a.layout, readonly = _a.readonly, hideLabel = _a.hideLabel;
    // readonly 只和 fixed 共存
    var formClassName = classnames_1.default("tea-form", {
        "tea-form--fixed-layout": layout === "fixed",
        "tea-form--vertical": !readonly && (layout === "vertical" || layout === "inline-vertical"),
        "tea-form--inline": !readonly && (layout === "inline" || layout === "inline-vertical"),
        "tea-form--readonly": readonly,
    }, className);
    return (react_1.default.createElement("div", { className: formClassName, style: style },
        react_1.default.createElement(FormContext_1.FormContext.Provider, { value: { hideLabel: hideLabel } }, children)));
}
exports.Form = Form;
exports.FormTitle = create_rocket_1.createRocket("Form.Title", "h3.tea-form-title");
exports.FormAction = create_rocket_1.createRocket("Form.Action", "div.tea-form-operate");
exports.FormText = create_rocket_1.createRocket("Form.Text", "div.tea-form__text");
Form.Item = FormItem_1.FormItem;
Form.Title = exports.FormTitle;
Form.Action = exports.FormAction;
Form.Control = FormControl_1.FormControl;
Form.Text = exports.FormText;
//# sourceMappingURL=Form.js.map