"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var controlled_1 = require("../form/controlled");
var forward_ref_with_statics_1 = require("../_util/forward-ref-with-statics");
exports.Input = forward_ref_with_statics_1.forwardRefWithStatics(function (props, ref) {
    var _a;
    var _b = controlled_1.useDefaultValue(props, ""), multiline = _b.multiline, children = _b.children, // never used
    placeholder = _b.placeholder, disabled = _b.disabled, readonly = _b.readonly, size = _b.size, type = _b.type, baseClassName = _b.baseClassName, className = _b.className, style = _b.style, value = _b.value, onChange = _b.onChange, restProps = tslib_1.__rest(_b, ["multiline", "children", "placeholder", "disabled", "readonly", "size", "type", "baseClassName", "className", "style", "value", "onChange"]);
    var basename = baseClassName || "tea-" + (multiline ? "textarea" : "input");
    var inputClassName = classnames_1.default((_a = {},
        _a[basename] = true,
        _a[className] = className,
        _a["size-" + (size === "full" ? size + "-width" : size)] = size,
        _a));
    var hasRows = multiline && restProps.rows;
    var inputProps = tslib_1.__assign({ placeholder: placeholder, className: inputClassName, readOnly: readonly, disabled: disabled, 
        // 受样式限制 rows 属性没有生效
        style: hasRows ? tslib_1.__assign({ height: "auto" }, (style || {})) : style, value: value, onChange: function (event) {
            return onChange(event.target.value, { event: event });
        } }, restProps);
    return multiline ? (react_1.default.createElement("textarea", tslib_1.__assign({ ref: ref }, inputProps))) : (react_1.default.createElement("input", tslib_1.__assign({ ref: ref, type: type }, inputProps)));
}, {
    // Input statics
    /**
     * 在表单布局中，和 label 的默认对齐方式
     */
    defaultLabelAlign: "middle",
});
exports.Input.displayName = "Input";
//# sourceMappingURL=Input.js.map