"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var icon_1 = require("../icon");
var MenuGroup_1 = require("./MenuGroup");
var SubMenu_1 = require("./SubMenu");
var MenuItem_1 = require("./MenuItem");
var use_default_1 = require("../_util/use-default");
var tooltip_1 = require("../tooltip");
var with_statics_1 = require("../_util/with-statics");
exports.Menu = with_statics_1.withStatics(function Menu(_a) {
    var _b;
    var theme = _a.theme, title = _a.title, tag = _a.tag, icon = _a.icon, back = _a.back, children = _a.children, className = _a.className, style = _a.style, collapsable = _a.collapsable, _c = _a.defaultCollapsed, defaultCollapsed = _c === void 0 ? false : _c, collapsed = _a.collapsed, onCollapsedChange = _a.onCollapsedChange;
    // eslint-disable-next-line no-param-reassign
    _b = tslib_1.__read(use_default_1.useDefault(collapsed, defaultCollapsed, onCollapsedChange), 2), collapsed = _b[0], onCollapsedChange = _b[1];
    var _d = tslib_1.__read(react_1.useState(false), 2), hovered = _d[0], setHovered = _d[1];
    if (Array.isArray(icon)) {
        // eslint-disable-next-line
        icon = icon[0];
    }
    var renderBack = typeof back === "object"
        ? function () {
            var title = back.title, description = back.description, _a = back.onClick, onClick = _a === void 0 ? function () { return null; } : _a, tooltip = back.tooltip;
            var titleList = (react_1.default.createElement("div", { className: "tea-menu__title-list" },
                react_1.default.createElement("div", { className: classnames_1.default("tea-h2", {
                        "tea-menu__title-main": !!description,
                    }) }, title),
                react_1.default.createElement("div", { className: "tea-menu__title-text" }, description)));
            return (react_1.default.createElement("div", { className: "tea-menu__title-back" },
                react_1.default.createElement("a", { className: "tea-menu__back", onClick: onClick },
                    react_1.default.createElement(icon_1.Icon, { type: "btnback" })),
                tooltip ? (react_1.default.createElement(tooltip_1.Tooltip, { title: tooltip }, titleList)) : (titleList)));
        }
        : function () { return null; };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: classnames_1.default("tea-menu", className, {
                "tea-menu--light": theme !== "dark",
                "tea-menu-is-locked": collapsed,
                "tea-menu-is-collapsed": collapsed && !hovered,
            }), style: style },
            react_1.default.createElement("div", { className: "tea-menu__header", onMouseEnter: function () { return collapsed && setHovered(true); }, onMouseLeave: function () { return collapsed && setHovered(false); } },
                !!title && (react_1.default.createElement("div", { className: "tea-menu__title" },
                    !!icon && (react_1.default.createElement("img", { className: "tea-menu__title-icon", src: icon, alt: "icon" })),
                    react_1.default.createElement("h2", { className: "tea-h2" },
                        title,
                        !!tag && (react_1.default.createElement("div", { className: "tea-tag" },
                            react_1.default.createElement("span", null, tag)))))),
                renderBack()),
            react_1.default.createElement("div", { className: "tea-menu__body", onMouseEnter: function () { return collapsed && setHovered(true); }, onMouseLeave: function () { return collapsed && setHovered(false); } },
                react_1.default.createElement("ul", { className: "tea-menu__list" }, children)),
            !!collapsable && (react_1.default.createElement("div", { className: "tea-menu__footer" },
                react_1.default.createElement("div", { className: "tea-menu__fold", onClick: function () { return onCollapsedChange(!collapsed); } },
                    react_1.default.createElement("div", { className: "tea-menu__fold-icon" },
                        react_1.default.createElement(icon_1.Icon, { type: "fold" }))))))));
}, {
    Group: MenuGroup_1.MenuGroup,
    SubMenu: SubMenu_1.SubMenu,
    Item: MenuItem_1.MenuItem,
});
//# sourceMappingURL=Menu.js.map