"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var call_both_1 = require("../_util/call-both");
function MenuItem(_a) {
    var _b;
    var title = _a.title, icon = _a.icon, selected = _a.selected, className = _a.className, style = _a.style, _c = _a.onClick, onClick = _c === void 0 ? function () { return null; } : _c, _d = _a.render, render = _d === void 0 ? function (children) { return react_1.default.createElement("a", null, children); } : _d;
    var defaultIcon;
    var activeIcon;
    if (typeof icon === "string") {
        defaultIcon = icon;
        activeIcon = icon;
    }
    if (Array.isArray(icon)) {
        _b = tslib_1.__read(icon, 2), defaultIcon = _b[0], activeIcon = _b[1];
    }
    var children = render(react_1.default.createElement(react_1.default.Fragment, null,
        defaultIcon && (react_1.default.createElement("img", { className: "tea-menu__list-icon", src: defaultIcon, alt: "icon" })),
        activeIcon && (react_1.default.createElement("img", { className: "tea-menu__list-icon is-selected", src: activeIcon, alt: "icon" })),
        react_1.default.createElement("div", { className: "tea-menu__text" }, title)));
    return (react_1.default.createElement("li", { className: classnames_1.default(className, { "is-selected": selected }), style: style }, react_1.default.cloneElement(children, {
        className: classnames_1.default("tea-menu__item", children.props.className),
        onClick: call_both_1.callBoth(onClick, children.props.onClick),
    })));
}
exports.MenuItem = MenuItem;
//# sourceMappingURL=MenuItem.js.map