"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var icon_1 = require("../icon");
var use_default_1 = require("../_util/use-default");
function SubMenu(_a) {
    var _b, _c;
    var title = _a.title, icon = _a.icon, children = _a.children, _d = _a.defaultOpened, defaultOpened = _d === void 0 ? false : _d, opened = _a.opened, onOpenedChange = _a.onOpenedChange, className = _a.className, style = _a.style;
    // eslint-disable-next-line no-param-reassign
    _b = tslib_1.__read(use_default_1.useDefault(opened, defaultOpened, onOpenedChange), 2), opened = _b[0], onOpenedChange = _b[1];
    var defaultIcon;
    var activeIcon;
    if (typeof icon === "string") {
        defaultIcon = icon;
        activeIcon = icon;
    }
    if (Array.isArray(icon)) {
        _c = tslib_1.__read(icon, 2), defaultIcon = _c[0], activeIcon = _c[1];
    }
    return (react_1.default.createElement("li", { className: classnames_1.default("tea-menu__submenu", className, {
            "is-selected": opened,
        }), style: style },
        react_1.default.createElement("a", { className: "tea-menu__item", onClick: function () { return onOpenedChange(!opened); } },
            defaultIcon && (react_1.default.createElement("img", { className: "tea-menu__list-icon", src: defaultIcon, alt: "icon" })),
            activeIcon && (react_1.default.createElement("img", { className: "tea-menu__list-icon is-selected", src: activeIcon, alt: "icon" })),
            react_1.default.createElement("div", { className: "tea-menu__text" }, title),
            react_1.default.createElement(icon_1.Icon, { type: "arrowdown" })),
        react_1.default.createElement("ul", { className: "tea-menu__list" }, children)));
}
exports.SubMenu = SubMenu;
//# sourceMappingURL=SubMenu.js.map