"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_popper_1 = require("react-popper");
var OverlayLayer_1 = require("./OverlayLayer");
/**
 * 为定位元素创建一个覆盖层
 *
 * @example
 *
  ```js
  const [visible, setVisible] = useState(false);
  const open = () => setVisible(true);
  const close = () => setVisible(false);
  <Overlay
    layers={[
      <Overlay.Layer
        visible={visible}
        content={<div>我是浮层内容，<a onClick={close}>关闭</a></div>}
      />
    ]}
    children={ref => <a ref={ref} onClick={open}>点击弹出浮层</a>}
  />
  ```
 */
function Overlay(_a) {
    var children = _a.children, layers = _a.layers;
    // 渲染定位组件
    return (react_1.default.createElement(react_popper_1.Manager, null,
        react_1.default.createElement(react_popper_1.Reference, null, function (_a) {
            var ref = _a.ref;
            return children(ref);
        }),
        layers));
}
exports.Overlay = Overlay;
Overlay.Layer = OverlayLayer_1.OverlayLayer;
//# sourceMappingURL=Overlay.js.map