"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
function Stepper(_a) {
    var _b;
    var type = _a.type, steps = _a.steps, current = _a.current, readonly = _a.readonly, nowrap = _a.nowrap, className = _a.className, style = _a.style;
    var stepperClassName = classnames_1.default((_b = {},
        _b["tea-step"] = true,
        _b["tea-step--alternative"] = type === "process",
        _b["tea-step--vertical"] = type === "process-vertical",
        _b["tea-step--dot"] = type === "process-vertical-dot",
        _b["tea-step--readonly"] = readonly,
        _b["tea-step--wrap-normal"] = nowrap,
        _b[className] = className,
        _b));
    return (react_1.default.createElement("div", { className: stepperClassName, style: style }, steps.map(function (step, index, steps) { return (react_1.default.createElement("div", { key: step.id, className: classnames_1.default("tea-step__item", {
            "is-current": !readonly && step.id === current,
        }) },
        react_1.default.createElement("div", { className: "tea-step__num" }, index + 1),
        react_1.default.createElement("div", { className: "tea-step__content" },
            react_1.default.createElement("div", { className: "tea-step__title" }, step.label),
            step.detail && (react_1.default.createElement("div", { className: "tea-step__description" }, step.detail))),
        step.tip && react_1.default.createElement("div", { className: "tea-step__tips" }, step.tip),
        index < steps.length - 1 && react_1.default.createElement("div", { className: "tea-step__arrow" }))); })));
}
exports.Stepper = Stepper;
//# sourceMappingURL=Stepper.js.map