import React from "react";
import { TableAddon } from "../TableProps";
/**
 * `rowtooltip` 插件用于支持为表格行生成 `tooltip`。
  ```jsx
  import { rowtooltip } from '@tea/component/table/addons/rowtooltip';
  function Example() {
    return <Table addons={[rowtooltip(options)]} />;
  }
  ```
 */
export interface RowTooltipAddonOption<T = any> {
    /**
     * 为指定的行生成 `tooltip` 内容，返回空则不显示 `tooltip`
     */
    tooltip: (record: T) => React.ReactNode;
}
export declare function rowtooltip<T = any>(options: RowTooltipAddonOption<T>): TableAddon<T>;
