"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var tooltip_1 = require("../../tooltip");
function rowtooltip(options) {
    return {
        onInjectRow: function (next) { return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result = next.apply(void 0, tslib_1.__spread(args));
            // 对于提供了 tooltip 的，用 tooltip 包裹
            var _a = tslib_1.__read(args, 1), record = _a[0];
            var tooltip = options.tooltip(record);
            if (tooltip) {
                result.row = (react_1.default.createElement(TooltipWrapper, { key: result.row.key, tooltip: tooltip }, result.row));
            }
            return result;
        }; },
    };
}
exports.rowtooltip = rowtooltip;
function TooltipWrapper(_a) {
    var children = _a.children, tooltip = _a.tooltip, props = tslib_1.__rest(_a, ["children", "tooltip"]);
    return (react_1.default.createElement(tooltip_1.Tooltip, { title: tooltip }, react_1.default.cloneElement(react_1.default.Children.only(children), props)));
}
//# sourceMappingURL=rowtooltip.js.map