import React from "react";
/**
 * 注入到外层容器，提供滚动上下文
 */
export declare function ScrollableTable({ table, scrollHeightFactor, onScrollBottom, ...props }: ScrollableTableProps): JSX.Element;
export declare namespace ScrollableTable {
    var displayName: string;
}
interface ScrollableTableProps {
    table: JSX.Element;
    scrollHeightFactor: any[];
    onScrollBottom?: (event: React.UIEvent) => void;
}
/**
 * 包装表格内容区（滚动部分），回调内容区 DOM 的实例
 */
export declare const ScrollableTableBody: React.ForwardRefExoticComponent<ScrollableTableBodyProps & React.RefAttributes<HTMLDivElement>>;
interface ScrollableTableBodyProps {
    body: React.FunctionComponentElement<{
        ref: React.Ref<HTMLDivElement>;
        style: React.CSSProperties;
        onScrollCapture: (event: React.UIEvent<HTMLDivElement>) => void;
    }>;
    style: React.CSSProperties;
}
/**
 * 包装表格头部，通过滚动状态调整右侧间距
 */
export declare const ScrollableTableHead: React.ForwardRefExoticComponent<ScrollableTableHeadProps & React.RefAttributes<HTMLDivElement>>;
interface ScrollableTableHeadProps {
    head: React.FunctionComponentElement<{
        ref: React.Ref<HTMLDivElement>;
        style: React.CSSProperties;
    }>;
}
export {};
