"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var icon_1 = require("../icon");
var text_1 = require("../text");
var i18n_1 = require("../i18n");
function ErrorTip(props) {
    var t = i18n_1.useTranslation();
    var _a = props.errorText, errorText = _a === void 0 ? t.loadErrorText : _a, _b = props.retryText, retryText = _b === void 0 ? t.loadRetryText : _b, onRetry = props.onRetry, hideIcon = props.hideIcon, className = props.className, style = props.style;
    return (react_1.default.createElement("span", { className: classnames_1.default("tea-action-state", className), style: style },
        !hideIcon && react_1.default.createElement(icon_1.Icon, { type: "error", className: "tea-mr-2n" }),
        typeof errorText === "string" ? (react_1.default.createElement(text_1.Text, { className: "tea-action-state__text", theme: "danger" }, errorText)) : (errorText),
        onRetry && (react_1.default.createElement(react_1.default.Fragment, null,
            " ",
            react_1.default.createElement("a", { className: "tea-action-state__text", onClick: onRetry }, retryText)))));
}
exports.ErrorTip = ErrorTip;
//# sourceMappingURL=ErrorTip.js.map