import { MetaData } from "../../type";

/* eslint-disable */
export function getTooltipContent(label: string, metaData: MetaData[]) {
  const title = `<h4 style="font-size:14px;color:#333;padding-bottom:10px">${label}</h4>`;
  let seriesText = "";
  for (const meta of metaData) {
    seriesText += `
    <p style="height:20px;line-height:20px;display:table-row;">
      ${
        metaData.length > 1
          ? `
        <span style="display:table-cell;line-height:20px;vertical-align:middle;padding-right:10px;">
          <i style="display:inline-block;height:4px;width:16px;background:${
            meta.color
          };"></i>
        </span>
      `
          : ""
      }
      <span style="display:table-cell;font-size:14px;color:#333;">${
        meta.label
      }</span>
      <span style="display:table-cell;font-weight:600;color:#333;font-size:14px;padding-left:15px;text-align:right;">${
        meta.value
      }</span>
    </p>`;
  }

  return `
  ${title}
  <div style="display:table;">
    ${seriesText}
  </div>
  `;
}
