export interface Theme {
  // 图表颜色序列
  color?: string[] | ((key: string, index: number, isLast: boolean) => string);

  // X 轴
  xAxis?: AxisTheme;

  // Y 轴
  yAxis?: AxisTheme;

  padding?: {
    top?: number;
    left?: number;
    bottom?: number;
    right?: number;
  };

  legend?: {
    height?: number;
    rect?: {
      height: number;
      width: number;
    };
    circle?: {
      radius: number;
    };
    square?: {
      width: number;
    };
    text?: {
      fontSize: number;
      color: string;
      disabledColor: string;
    };
  };
}

export interface AxisTheme {
  // 轴线
  axisLine?: {
    lineStyle?: {
      color?: string;
    };
  };
  // 轴刻度
  axisTick?: {
    lineStyle?: {
      color?: string;
    };
  };
  // 轴标签
  axisLabel?: {
    color?: string;
  };
  // 分割线
  splitLine?: {
    show?: boolean;
    lineStyle?: {
      color?: string[];
    };
  };
}
