import React, { Fragment } from "react";
import { BasicLine } from "@tea/component/basicline";

export default function DomainExample() {
  const dataCount = 1000;
  const data = [];
  const date = new Date();
  for (let i = 0; i < dataCount; i++) {
    data.push({
      time: `${date.getHours()}:${date.getMinutes()}`,
      // 设值域为 [3000, 5000]
      value: Math.floor(Math.random() * (5000 - 4000) + 4000),
    });
    const dateTime = date.getTime();
    date.setTime(dateTime + 60000);
  }

  return (
    <Fragment>
      <BasicLine
        height={250}
        position="time*value"
        size={1}
        scale={{
          value: {
            alias: "值",
            domain: [2000, 6000],
          },
        }}
        dataSource={data}
      />
    </Fragment>
  );
}
