import React, { Fragment, useState } from "react";
import { BasicLine } from "@tea/component/basicline";
import { Button } from "@tea/component/button";
import { StatusTip } from "@tea/component/tips";

export default function StatusBasicLineExample() {
  const [data, setData] = useState([]);
  const [status, setStatus] = useState(null);

  const refresh = () => {
    setStatus("loading");
    setTimeout(() => {
      setStatus(null);
      setData([
        { time: "0:00", value: 10 },
        { time: "1:00", value: 20 },
        { time: "2:00", value: 50 },
        { time: "3:00", value: 60 },
        { time: "4:00", value: 20 },
        { time: "5:00", value: 72 },
        { time: "6:00", value: 98 },
        { time: "7:00", value: 60 },
        { time: "8:00", value: 70 },
        { time: "9:00", value: 58 },
        { time: "10:00", value: 22 },
        { time: "11:00", value: 68 },
        { time: "12:00", value: 83 },
      ]);
    }, 2000);
  };

  return (
    <Fragment>
      <Button onClick={refresh}>点击刷新</Button>
      <BasicLine
        height={250}
        position="time*value"
        dataSource={data}
        tips={status && <StatusTip status={status} />}
      />
    </Fragment>
  );
}
