import React, { useState, Fragment } from "react";
import { Card } from "@tea/component/card";
import { Button } from "@tea/component/button";
import { Switch } from "@tea/component/switch";

export default function CardExample() {
  const [headerVisible, setHeaderVisible] = useState(false);
  const [footerVisible, setFooterVisible] = useState(false);
  const [borderVisible, setBorderVisible] = useState(false);

  return (
    <Fragment>
      <section>
        <Switch
          value={headerVisible}
          onChange={value => setHeaderVisible(value)}
        >
          显示头部
        </Switch>
        <Switch
          value={footerVisible}
          onChange={value => setFooterVisible(value)}
        >
          显示底部
        </Switch>
        <Switch
          value={borderVisible}
          onChange={value => setBorderVisible(value)}
        >
          显示边框
        </Switch>
      </section>
      <div className="example-stage">
        <Card bordered={borderVisible}>
          {headerVisible && (
            <Card.Header>
              <h3>卡片头部</h3>
            </Card.Header>
          )}
          <Card.Body
            title="内容区标题"
            subtitle="(小标题)"
            operation={<Button type="link">操作区</Button>}
          >
            内容区
          </Card.Body>
          {footerVisible && (
            <Card.Footer>
              <p className="tea-pt-5n tea-pb-5n tea-pl-5n">卡片底部</p>
            </Card.Footer>
          )}
        </Card>
      </div>
    </Fragment>
  );
}
