import React from "react";
import { Cascader } from "@tea/component/cascader";

const data = {
  title: "省份",
  options: [
    {
      label: "北京市",
      value: "bj",
      child: {
        title: "区县",
        options: [
          { label: "朝阳区", value: "cy" },
          { label: "海淀区", value: "hd" },
        ],
      },
    },
    {
      label: "上海市",
      value: "sh",
      child: {
        title: "区县",
        options: [
          { label: "徐汇区", value: "xh" },
          { label: "黄埔区", value: "hp" },
        ],
      },
    },
    {
      label: "广东省",
      value: "gd",
      child: {
        title: "城市",
        options: [
          {
            label: "深圳市",
            value: "sz",
            child: {
              title: "区县",
              options: [
                { label: "南山区", value: "ns" },
                { label: "宝安区", value: "ba" },
              ],
            },
          },
        ],
      },
    },
  ],
};

export default function CascaderExample() {
  return (
    <Cascader
      data={data}
      onChange={(value, { options }) => console.log(value, options)}
    />
  );
}
