# DatePicker 日期选择

提供日期选择、月份选择及范围选择控件。

## 依赖安装

日期相关组件实现依赖了 [moment](http://momentjs.com/)，使用时需自行安装：

```
npm install moment
```

如果你的 webpack 配置中忽略了 moment 的语言包（如 `create-react-app` 创建的应用），请手动引入需要的语言包，如：

```js
import "moment/locale/zh-cn";
```

## 使用示例

### 日期选择

最简单的用法，选择独立的一日。

[Example: DatePicker](./_example/DatePickerExample.jsx)

### 月份选择

[Example: MonthPicker](./_example/MonthPickerExample.jsx)

### 区间选择

[Example: RangePicker](./_example/RangePickerExample.jsx)

### 限制可选范围（range）

[Example: DatePickerRange](./_example/DatePickerRangeExample.jsx)

### 限制可选范围（disabled 函数）

[Example: RangePickerDisabled](./_example/RangePickerDisabledExample.jsx)

### 搭配预置选项卡

[Example: PickerWithSegment](./_example/PickerWithSegmentExample.jsx)

## 组件属性

[Interface: DatePickerProps](./DatePicker.tsx)

[Interface: MonthPickerProps](./MonthPicker.tsx)

[Interface: RangePickerProps](./RangePicker.tsx)
