import React from "react";
import { Dropdown } from "@tea/component/dropdown";
import { List } from "@tea/component/list";
import { Button } from "@tea/component/button";

export default function DropdownExample() {
  const menu = close => (
    <List type="option">
      <List.Item onClick={close}>预付费</List.Item>
      <List.Item onClick={close}>后付费</List.Item>
      <List.SubMenu label="更多">
        <List type="option">
          <List.Item disabled>订阅</List.Item>
          <List.Item onClick={close}>朋友代付</List.Item>
        </List>
      </List.SubMenu>
    </List>
  );

  return (
    <>
      <Dropdown
        trigger="hover"
        clickClose={false}
        style={{ marginRight: 10 }}
        button="Hover me"
        onOpen={() => console.log("open")}
        onClose={() => console.log("close")}
      >
        {menu}
      </Dropdown>
      <Dropdown
        clickClose={false}
        style={{ marginRight: 10 }}
        button="按钮样式"
        appearence="button"
        onOpen={() => console.log("open")}
        onClose={() => console.log("close")}
      >
        {menu}
      </Dropdown>
      <Dropdown
        clickClose={false}
        style={{ marginRight: 10 }}
        button="链接样式"
        appearence="link"
        placement="top"
      >
        {menu}
      </Dropdown>
      <Dropdown
        clickClose={false}
        style={{ marginRight: 10 }}
        button="筛选"
        appearence="filter"
      >
        {menu}
      </Dropdown>
      <Dropdown
        clickClose={false}
        style={{ marginRight: 10 }}
        button={<Button type="icon" icon="more" />}
        appearence="pure"
      >
        {menu}
      </Dropdown>

      <br />
    </>
  );
}
