import React, { useState } from "react";
import { MediaObject } from "@tea/component/mediaobject";
import { Segment } from "@tea/component/segment";
import { Switch } from "@tea/component/switch";

const media = <img src="//placehold.it/64x64" alt="Generic placeholder" />;

const content = (
  <>
    <h4 className="tea-h4 tea-mb-2n">Media heading</h4>
    <p>
      Cras sit amet nibh libero, in gravida nulla. Nulla vel metus scelerisque
      ante sollicitudin commodo. Cras purus odio, vestibulum in vulputate at,
      tempus viverra turpis. Fusce condimentum nunc ac nisi vulputate fringilla.
      Donec lacinia congue felis in faucibus. Cras sit amet nibh libero, in
      gravida nulla. Nulla vel metus scelerisque ante sollicitudin commodo. Cras
      purus odio, vestibulum in vulputate at, tempus viverra turpis. Fusce
      condimentum nunc ac nisi vulputate fringilla. Donec lacinia congue felis
      in faucibus.
    </p>
  </>
);

export default function MediaObjectExample() {
  const [align, setAlign] = useState("top");
  const [reverse, setReverse] = useState(false);

  return (
    <>
      <MediaObject
        media={media}
        // @ts-ignore
        align={align}
        reverse={reverse}
      >
        {content}
      </MediaObject>
      <section>
        对齐方式：
        <Segment
          options={[{ value: "top" }, { value: "middle" }, { value: "bottom" }]}
          value={align}
          onChange={value => setAlign(value)}
        />
      </section>
      <section>
        反置：
        <Switch value={reverse} onChange={value => setReverse(value)} />
      </section>
    </>
  );
}
