import React, { Fragment, useState } from "react";
import { Stepper } from "@tea/component/stepper";
import { Switch } from "@tea/component/switch";

export default function StepperExample() {
  const steps = [
    { id: "prepare", label: "备案类型" },
    { id: "info", label: "备案信息" },
    {
      id: "upload",
      label: "上传资料",
      detail: (
        <Fragment>
          <strong>资料审核中</strong>
          <br />
          腾讯云会在 <strong>1 个工作日内</strong>审核完成，请耐心等候。
          <a>催单处理</a>
        </Fragment>
      ),
    },
    { id: "photo", label: "办理拍照" },
    { id: "finish", label: "完成备案" },
  ];

  const [dot, setDot] = useState(false);

  return (
    <Fragment>
      <Stepper
        type={dot ? "process-vertical-dot" : "process-vertical"}
        current="upload"
        steps={steps}
      />
      <section>
        <Switch value={dot} onChange={value => setDot(value)}>
          使用圆点样式
        </Switch>
      </section>
    </Fragment>
  );
}
