# Table 表格

表格可以清晰地展示二维数据。

## 基本用法

[Example: 表格示例](./_example/TableExample.jsx)

## 布局示例

[Example: 布局示例](./_example/TableLayoutExample.jsx)

Table 上方操作区域需用 **Table.ActionPanel** 包裹。

## 插件使用

通过插件可以支持更多复杂功能，如排序、筛选、滚动。

[Example: 插件](./_example/TableAddonExample.jsx)

## 自动提示条

[Example: 自动提示条](./_example/TableAutoTipsExample.jsx)

## 提示条

[Example: 提示条](./_example/TableTipsExample.jsx)

## 复杂示例

[Example: 复杂示例](./_example/TableComplexExample.jsx)

## 组件属性

[Interface: TableProps](./TableProps.ts)

<!-- [Interface: TableAddon](./TableProps.ts) -->

## 插件 API

[Interface: AutoTipOptions](./addons/autotip.tsx)

[Interface: ExpandableAddonOptions](./addons/expandable.tsx)

[Interface: FilterableConfig](./addons/filterable/FilterableTypes.ts)

[Interface: SingleFilterableConfig](./addons/filterable/FilterableTypes.ts)

[Interface: MultipleFilterableConfig](./addons/filterable/FilterableTypes.ts)

[Interface: IndentableOptions](./addons/indentable.tsx)

[Interface: InjectableOptions](./addons/injectable.ts)

[Interface: RemoveableOptions](./addons/removeable.tsx)

[Interface: RowTooltipAddonOption](./addons/rowtooltip.tsx)

[Interface: RadioableOptions](./addons/radioable.tsx)

[Interface: ScrollableAddonOptions](./addons/scrollable/scrollable.tsx)

[Interface: SelectableOptions](./addons/selectable.tsx)

[Interface: SortableOptions](./addons/sortable.tsx)

[Interface: StylizeOption](./addons/stylize.tsx)

## 从 Tea v1 升级

- 组件名从 `TablePanel` 更名为 `Table`
- 表格行的选择，不再内置，改为从 `table/addon/selectable` 提供
- 表格行的展开，不再内置，改为从 `table/addon/expandable` 提供
- 移除 `topTipStyle` 和 `bottomTipStyle` 配置，如需配置请自行提供带样式的 tips
- 为了命名一致，`recordDisabled` 更名为 `rowDisabled`
