import { TableProps } from "../TableProps";

export function getRowKeyfromRecordKey(recordKey: TableProps["recordKey"]) {
  let getRowKey: Exclude<typeof recordKey, string> = null;
  if (typeof recordKey === "function") {
    getRowKey = recordKey;
  } else if (typeof recordKey === "string") {
    const keyName = recordKey;
    getRowKey = (record, recordIndex) => String(record[keyName]);
  } else {
    // 如果未提供 rowKey，使用索引生成
    // TODO: 输出告警
    getRowKey = (record, recordIndex) => `record_${recordIndex}`;
  }
  return getRowKey;
}
