import React from "react";
import moment from "moment";
import { TimePicker } from "@tea/component/timepicker";

export default () => {
  return (
    <>
      <section>
        <TimePicker
          defaultValue={moment("23:30:00", "HH:mm:ss")}
          onChange={value => console.log(value)}
          onOpenChange={open => console.log(open ? "open" : "close")}
        />
      </section>
      <section>
        <TimePicker disabled defaultValue={moment("23:30:00", "HH:mm:ss")} />
      </section>
      <section>
        <TimePicker
          format="HH:mm"
          defaultValue={moment("18:30", "HH:mm")}
          hourStep={2}
          minuteStep={10}
          onChange={value => console.log(value)}
          onOpenChange={open => console.log(open ? "open" : "close")}
        />
      </section>
    </>
  );
};
