import React from "react";
import { Tree } from "@tea/component/tree";
import { Icon } from "@tea/component/icon";

export default function TreeIconExample() {
  const parentIcon = ({ expanded }) => (
    <Icon type={expanded ? "folderopen" : "folderclose"} />
  );

  const leafIcon = <Icon type="phone" />;

  return (
    <Tree
      activable
      onActive={console.log}
      defaultExpandedIds={["0-0", "0-0-0"]}
    >
      <Tree.Node id="0-0" content="0-0" icon={parentIcon}>
        <Tree.Node id="0-0-0" content="0-0-0" icon={parentIcon}>
          <Tree.Node id="0-0-0-1" content="0-0-0-1" icon={leafIcon} />
          <Tree.Node id="0-0-0-2" content="0-0-0-2" icon={leafIcon} />
        </Tree.Node>
        <Tree.Node id="0-0-1" content="0-0-1" icon={parentIcon}>
          <Tree.Node id="0-0-1-1" content="0-0-1-1" icon={leafIcon} />
          <Tree.Node id="0-0-1-2" content="0-0-1-2" icon={leafIcon} />
        </Tree.Node>
      </Tree.Node>
    </Tree>
  );
}
