import React, { useState } from "react";
import { Tree } from "@tea/component/tree";
import { Dropdown } from "@tea/component/dropdown";
import { List } from "@tea/component/list";

export default function TreeOperationExample() {
  const [selectIds, setSelectIds] = useState([]);
  return (
    <Tree
      selectable
      selectedIds={selectIds}
      onSelect={(value, context) => {
        console.log(value, context);
        setSelectIds(value);
      }}
    >
      <Tree.Node
        id="0-0"
        content="分组一很长很长很长很长很长很长很长很长很长很长很长很长很长很长很长很长很长很长很长很长很长很长"
        operation={<Tree.Node.ActionLink>新增</Tree.Node.ActionLink>}
      >
        <Tree.Node id="0-0-0" content="0-0-0" />
      </Tree.Node>
      <Tree.Node
        id="0-1"
        content="0-1"
        operation={
          <Dropdown appearence="link" button="操作">
            <List type="option">
              <List.Item>操作一</List.Item>
              <List.Item>操作二</List.Item>
            </List>
          </Dropdown>
        }
      >
        <Tree.Node id="0-1-0" content="0-1-0">
          <Tree.Node id="0-1-0-1" content="0-1-0-1" />
          <Tree.Node id="0-1-0-2" content="0-1-0-2" />
        </Tree.Node>
      </Tree.Node>
    </Tree>
  );
}
