/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	auth "tkestack.io/tke/api/auth"
)

// FakeLocalIdentities implements LocalIdentityInterface
type FakeLocalIdentities struct {
	Fake *FakeAuth
}

var localidentitiesResource = schema.GroupVersionResource{Group: "auth.tkestack.io", Version: "", Resource: "localidentities"}

var localidentitiesKind = schema.GroupVersionKind{Group: "auth.tkestack.io", Version: "", Kind: "LocalIdentity"}

// Get takes name of the localIdentity, and returns the corresponding localIdentity object, and an error if there is any.
func (c *FakeLocalIdentities) Get(name string, options v1.GetOptions) (result *auth.LocalIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(localidentitiesResource, name), &auth.LocalIdentity{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalIdentity), err
}

// List takes label and field selectors, and returns the list of LocalIdentities that match those selectors.
func (c *FakeLocalIdentities) List(opts v1.ListOptions) (result *auth.LocalIdentityList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(localidentitiesResource, localidentitiesKind, opts), &auth.LocalIdentityList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &auth.LocalIdentityList{ListMeta: obj.(*auth.LocalIdentityList).ListMeta}
	for _, item := range obj.(*auth.LocalIdentityList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested localIdentities.
func (c *FakeLocalIdentities) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(localidentitiesResource, opts))
}

// Create takes the representation of a localIdentity and creates it.  Returns the server's representation of the localIdentity, and an error, if there is any.
func (c *FakeLocalIdentities) Create(localIdentity *auth.LocalIdentity) (result *auth.LocalIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(localidentitiesResource, localIdentity), &auth.LocalIdentity{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalIdentity), err
}

// Update takes the representation of a localIdentity and updates it. Returns the server's representation of the localIdentity, and an error, if there is any.
func (c *FakeLocalIdentities) Update(localIdentity *auth.LocalIdentity) (result *auth.LocalIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(localidentitiesResource, localIdentity), &auth.LocalIdentity{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalIdentity), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeLocalIdentities) UpdateStatus(localIdentity *auth.LocalIdentity) (*auth.LocalIdentity, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(localidentitiesResource, "status", localIdentity), &auth.LocalIdentity{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalIdentity), err
}

// Delete takes name of the localIdentity and deletes it. Returns an error if one occurs.
func (c *FakeLocalIdentities) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(localidentitiesResource, name), &auth.LocalIdentity{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeLocalIdentities) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(localidentitiesResource, listOptions)

	_, err := c.Fake.Invokes(action, &auth.LocalIdentityList{})
	return err
}

// Patch applies the patch and returns the patched localIdentity.
func (c *FakeLocalIdentities) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *auth.LocalIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(localidentitiesResource, name, pt, data, subresources...), &auth.LocalIdentity{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalIdentity), err
}
