/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	platform "tkestack.io/tke/api/platform"
)

// FakeTappControllers implements TappControllerInterface
type FakeTappControllers struct {
	Fake *FakePlatform
}

var tappcontrollersResource = schema.GroupVersionResource{Group: "platform.tkestack.io", Version: "", Resource: "tappcontrollers"}

var tappcontrollersKind = schema.GroupVersionKind{Group: "platform.tkestack.io", Version: "", Kind: "TappController"}

// Get takes name of the tappController, and returns the corresponding tappController object, and an error if there is any.
func (c *FakeTappControllers) Get(name string, options v1.GetOptions) (result *platform.TappController, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(tappcontrollersResource, name), &platform.TappController{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platform.TappController), err
}

// List takes label and field selectors, and returns the list of TappControllers that match those selectors.
func (c *FakeTappControllers) List(opts v1.ListOptions) (result *platform.TappControllerList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(tappcontrollersResource, tappcontrollersKind, opts), &platform.TappControllerList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &platform.TappControllerList{ListMeta: obj.(*platform.TappControllerList).ListMeta}
	for _, item := range obj.(*platform.TappControllerList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tappControllers.
func (c *FakeTappControllers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(tappcontrollersResource, opts))
}

// Create takes the representation of a tappController and creates it.  Returns the server's representation of the tappController, and an error, if there is any.
func (c *FakeTappControllers) Create(tappController *platform.TappController) (result *platform.TappController, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(tappcontrollersResource, tappController), &platform.TappController{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platform.TappController), err
}

// Update takes the representation of a tappController and updates it. Returns the server's representation of the tappController, and an error, if there is any.
func (c *FakeTappControllers) Update(tappController *platform.TappController) (result *platform.TappController, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(tappcontrollersResource, tappController), &platform.TappController{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platform.TappController), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeTappControllers) UpdateStatus(tappController *platform.TappController) (*platform.TappController, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(tappcontrollersResource, "status", tappController), &platform.TappController{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platform.TappController), err
}

// Delete takes name of the tappController and deletes it. Returns an error if one occurs.
func (c *FakeTappControllers) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(tappcontrollersResource, name), &platform.TappController{})
	return err
}

// Patch applies the patch and returns the patched tappController.
func (c *FakeTappControllers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *platform.TappController, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(tappcontrollersResource, name, pt, data, subresources...), &platform.TappController{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platform.TappController), err
}
