/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	authv1 "tkestack.io/tke/api/auth/v1"
)

// FakeClients implements ClientInterface
type FakeClients struct {
	Fake *FakeAuthV1
}

var clientsResource = schema.GroupVersionResource{Group: "auth.tkestack.io", Version: "v1", Resource: "clients"}

var clientsKind = schema.GroupVersionKind{Group: "auth.tkestack.io", Version: "v1", Kind: "Client"}

// Get takes name of the client, and returns the corresponding client object, and an error if there is any.
func (c *FakeClients) Get(name string, options v1.GetOptions) (result *authv1.Client, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(clientsResource, name), &authv1.Client{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Client), err
}

// List takes label and field selectors, and returns the list of Clients that match those selectors.
func (c *FakeClients) List(opts v1.ListOptions) (result *authv1.ClientList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(clientsResource, clientsKind, opts), &authv1.ClientList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &authv1.ClientList{ListMeta: obj.(*authv1.ClientList).ListMeta}
	for _, item := range obj.(*authv1.ClientList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested clients.
func (c *FakeClients) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(clientsResource, opts))
}

// Create takes the representation of a client and creates it.  Returns the server's representation of the client, and an error, if there is any.
func (c *FakeClients) Create(client *authv1.Client) (result *authv1.Client, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(clientsResource, client), &authv1.Client{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Client), err
}

// Update takes the representation of a client and updates it. Returns the server's representation of the client, and an error, if there is any.
func (c *FakeClients) Update(client *authv1.Client) (result *authv1.Client, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(clientsResource, client), &authv1.Client{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Client), err
}

// Delete takes name of the client and deletes it. Returns an error if one occurs.
func (c *FakeClients) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(clientsResource, name), &authv1.Client{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeClients) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(clientsResource, listOptions)

	_, err := c.Fake.Invokes(action, &authv1.ClientList{})
	return err
}

// Patch applies the patch and returns the patched client.
func (c *FakeClients) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *authv1.Client, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(clientsResource, name, pt, data, subresources...), &authv1.Client{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Client), err
}
