/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	businessv1 "tkestack.io/tke/api/business/v1"
)

// FakeImageNamespaces implements ImageNamespaceInterface
type FakeImageNamespaces struct {
	Fake *FakeBusinessV1
	ns   string
}

var imagenamespacesResource = schema.GroupVersionResource{Group: "business.tkestack.io", Version: "v1", Resource: "imagenamespaces"}

var imagenamespacesKind = schema.GroupVersionKind{Group: "business.tkestack.io", Version: "v1", Kind: "ImageNamespace"}

// Get takes name of the imageNamespace, and returns the corresponding imageNamespace object, and an error if there is any.
func (c *FakeImageNamespaces) Get(name string, options v1.GetOptions) (result *businessv1.ImageNamespace, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(imagenamespacesResource, c.ns, name), &businessv1.ImageNamespace{})

	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.ImageNamespace), err
}

// List takes label and field selectors, and returns the list of ImageNamespaces that match those selectors.
func (c *FakeImageNamespaces) List(opts v1.ListOptions) (result *businessv1.ImageNamespaceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(imagenamespacesResource, imagenamespacesKind, c.ns, opts), &businessv1.ImageNamespaceList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &businessv1.ImageNamespaceList{ListMeta: obj.(*businessv1.ImageNamespaceList).ListMeta}
	for _, item := range obj.(*businessv1.ImageNamespaceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested imageNamespaces.
func (c *FakeImageNamespaces) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(imagenamespacesResource, c.ns, opts))

}

// Create takes the representation of a imageNamespace and creates it.  Returns the server's representation of the imageNamespace, and an error, if there is any.
func (c *FakeImageNamespaces) Create(imageNamespace *businessv1.ImageNamespace) (result *businessv1.ImageNamespace, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(imagenamespacesResource, c.ns, imageNamespace), &businessv1.ImageNamespace{})

	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.ImageNamespace), err
}

// Update takes the representation of a imageNamespace and updates it. Returns the server's representation of the imageNamespace, and an error, if there is any.
func (c *FakeImageNamespaces) Update(imageNamespace *businessv1.ImageNamespace) (result *businessv1.ImageNamespace, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(imagenamespacesResource, c.ns, imageNamespace), &businessv1.ImageNamespace{})

	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.ImageNamespace), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeImageNamespaces) UpdateStatus(imageNamespace *businessv1.ImageNamespace) (*businessv1.ImageNamespace, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(imagenamespacesResource, "status", c.ns, imageNamespace), &businessv1.ImageNamespace{})

	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.ImageNamespace), err
}

// Delete takes name of the imageNamespace and deletes it. Returns an error if one occurs.
func (c *FakeImageNamespaces) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(imagenamespacesResource, c.ns, name), &businessv1.ImageNamespace{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeImageNamespaces) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(imagenamespacesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &businessv1.ImageNamespaceList{})
	return err
}

// Patch applies the patch and returns the patched imageNamespace.
func (c *FakeImageNamespaces) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *businessv1.ImageNamespace, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(imagenamespacesResource, c.ns, name, pt, data, subresources...), &businessv1.ImageNamespace{})

	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.ImageNamespace), err
}
