/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	businessv1 "tkestack.io/tke/api/business/v1"
)

// FakePlatforms implements PlatformInterface
type FakePlatforms struct {
	Fake *FakeBusinessV1
}

var platformsResource = schema.GroupVersionResource{Group: "business.tkestack.io", Version: "v1", Resource: "platforms"}

var platformsKind = schema.GroupVersionKind{Group: "business.tkestack.io", Version: "v1", Kind: "Platform"}

// Get takes name of the platform, and returns the corresponding platform object, and an error if there is any.
func (c *FakePlatforms) Get(name string, options v1.GetOptions) (result *businessv1.Platform, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(platformsResource, name), &businessv1.Platform{})
	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.Platform), err
}

// List takes label and field selectors, and returns the list of Platforms that match those selectors.
func (c *FakePlatforms) List(opts v1.ListOptions) (result *businessv1.PlatformList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(platformsResource, platformsKind, opts), &businessv1.PlatformList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &businessv1.PlatformList{ListMeta: obj.(*businessv1.PlatformList).ListMeta}
	for _, item := range obj.(*businessv1.PlatformList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested platforms.
func (c *FakePlatforms) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(platformsResource, opts))
}

// Create takes the representation of a platform and creates it.  Returns the server's representation of the platform, and an error, if there is any.
func (c *FakePlatforms) Create(platform *businessv1.Platform) (result *businessv1.Platform, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(platformsResource, platform), &businessv1.Platform{})
	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.Platform), err
}

// Update takes the representation of a platform and updates it. Returns the server's representation of the platform, and an error, if there is any.
func (c *FakePlatforms) Update(platform *businessv1.Platform) (result *businessv1.Platform, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(platformsResource, platform), &businessv1.Platform{})
	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.Platform), err
}

// Delete takes name of the platform and deletes it. Returns an error if one occurs.
func (c *FakePlatforms) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(platformsResource, name), &businessv1.Platform{})
	return err
}

// Patch applies the patch and returns the patched platform.
func (c *FakePlatforms) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *businessv1.Platform, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(platformsResource, name, pt, data, subresources...), &businessv1.Platform{})
	if obj == nil {
		return nil, err
	}
	return obj.(*businessv1.Platform), err
}
