/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	notifyv1 "tkestack.io/tke/api/notify/v1"
)

// FakeReceiverGroups implements ReceiverGroupInterface
type FakeReceiverGroups struct {
	Fake *FakeNotifyV1
}

var receivergroupsResource = schema.GroupVersionResource{Group: "notify.tkestack.io", Version: "v1", Resource: "receivergroups"}

var receivergroupsKind = schema.GroupVersionKind{Group: "notify.tkestack.io", Version: "v1", Kind: "ReceiverGroup"}

// Get takes name of the receiverGroup, and returns the corresponding receiverGroup object, and an error if there is any.
func (c *FakeReceiverGroups) Get(name string, options v1.GetOptions) (result *notifyv1.ReceiverGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(receivergroupsResource, name), &notifyv1.ReceiverGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.ReceiverGroup), err
}

// List takes label and field selectors, and returns the list of ReceiverGroups that match those selectors.
func (c *FakeReceiverGroups) List(opts v1.ListOptions) (result *notifyv1.ReceiverGroupList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(receivergroupsResource, receivergroupsKind, opts), &notifyv1.ReceiverGroupList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &notifyv1.ReceiverGroupList{ListMeta: obj.(*notifyv1.ReceiverGroupList).ListMeta}
	for _, item := range obj.(*notifyv1.ReceiverGroupList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested receiverGroups.
func (c *FakeReceiverGroups) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(receivergroupsResource, opts))
}

// Create takes the representation of a receiverGroup and creates it.  Returns the server's representation of the receiverGroup, and an error, if there is any.
func (c *FakeReceiverGroups) Create(receiverGroup *notifyv1.ReceiverGroup) (result *notifyv1.ReceiverGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(receivergroupsResource, receiverGroup), &notifyv1.ReceiverGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.ReceiverGroup), err
}

// Update takes the representation of a receiverGroup and updates it. Returns the server's representation of the receiverGroup, and an error, if there is any.
func (c *FakeReceiverGroups) Update(receiverGroup *notifyv1.ReceiverGroup) (result *notifyv1.ReceiverGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(receivergroupsResource, receiverGroup), &notifyv1.ReceiverGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.ReceiverGroup), err
}

// Delete takes name of the receiverGroup and deletes it. Returns an error if one occurs.
func (c *FakeReceiverGroups) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(receivergroupsResource, name), &notifyv1.ReceiverGroup{})
	return err
}

// Patch applies the patch and returns the patched receiverGroup.
func (c *FakeReceiverGroups) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *notifyv1.ReceiverGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(receivergroupsResource, name, pt, data, subresources...), &notifyv1.ReceiverGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.ReceiverGroup), err
}
