/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	platformv1 "tkestack.io/tke/api/platform/v1"
)

// FakeGPUManagers implements GPUManagerInterface
type FakeGPUManagers struct {
	Fake *FakePlatformV1
}

var gpumanagersResource = schema.GroupVersionResource{Group: "platform.tkestack.io", Version: "v1", Resource: "gpumanagers"}

var gpumanagersKind = schema.GroupVersionKind{Group: "platform.tkestack.io", Version: "v1", Kind: "GPUManager"}

// Get takes name of the gPUManager, and returns the corresponding gPUManager object, and an error if there is any.
func (c *FakeGPUManagers) Get(name string, options v1.GetOptions) (result *platformv1.GPUManager, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(gpumanagersResource, name), &platformv1.GPUManager{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platformv1.GPUManager), err
}

// List takes label and field selectors, and returns the list of GPUManagers that match those selectors.
func (c *FakeGPUManagers) List(opts v1.ListOptions) (result *platformv1.GPUManagerList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(gpumanagersResource, gpumanagersKind, opts), &platformv1.GPUManagerList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &platformv1.GPUManagerList{ListMeta: obj.(*platformv1.GPUManagerList).ListMeta}
	for _, item := range obj.(*platformv1.GPUManagerList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested gPUManagers.
func (c *FakeGPUManagers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(gpumanagersResource, opts))
}

// Create takes the representation of a gPUManager and creates it.  Returns the server's representation of the gPUManager, and an error, if there is any.
func (c *FakeGPUManagers) Create(gPUManager *platformv1.GPUManager) (result *platformv1.GPUManager, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(gpumanagersResource, gPUManager), &platformv1.GPUManager{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platformv1.GPUManager), err
}

// Update takes the representation of a gPUManager and updates it. Returns the server's representation of the gPUManager, and an error, if there is any.
func (c *FakeGPUManagers) Update(gPUManager *platformv1.GPUManager) (result *platformv1.GPUManager, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(gpumanagersResource, gPUManager), &platformv1.GPUManager{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platformv1.GPUManager), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeGPUManagers) UpdateStatus(gPUManager *platformv1.GPUManager) (*platformv1.GPUManager, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(gpumanagersResource, "status", gPUManager), &platformv1.GPUManager{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platformv1.GPUManager), err
}

// Delete takes name of the gPUManager and deletes it. Returns an error if one occurs.
func (c *FakeGPUManagers) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(gpumanagersResource, name), &platformv1.GPUManager{})
	return err
}

// Patch applies the patch and returns the patched gPUManager.
func (c *FakeGPUManagers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *platformv1.GPUManager, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(gpumanagersResource, name, pt, data, subresources...), &platformv1.GPUManager{})
	if obj == nil {
		return nil, err
	}
	return obj.(*platformv1.GPUManager), err
}
