/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by lister-gen. DO NOT EDIT.

package internalversion

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	business "tkestack.io/tke/api/business"
)

// ImageNamespaceLister helps list ImageNamespaces.
type ImageNamespaceLister interface {
	// List lists all ImageNamespaces in the indexer.
	List(selector labels.Selector) (ret []*business.ImageNamespace, err error)
	// ImageNamespaces returns an object that can list and get ImageNamespaces.
	ImageNamespaces(namespace string) ImageNamespaceNamespaceLister
	ImageNamespaceListerExpansion
}

// imageNamespaceLister implements the ImageNamespaceLister interface.
type imageNamespaceLister struct {
	indexer cache.Indexer
}

// NewImageNamespaceLister returns a new ImageNamespaceLister.
func NewImageNamespaceLister(indexer cache.Indexer) ImageNamespaceLister {
	return &imageNamespaceLister{indexer: indexer}
}

// List lists all ImageNamespaces in the indexer.
func (s *imageNamespaceLister) List(selector labels.Selector) (ret []*business.ImageNamespace, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*business.ImageNamespace))
	})
	return ret, err
}

// ImageNamespaces returns an object that can list and get ImageNamespaces.
func (s *imageNamespaceLister) ImageNamespaces(namespace string) ImageNamespaceNamespaceLister {
	return imageNamespaceNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// ImageNamespaceNamespaceLister helps list and get ImageNamespaces.
type ImageNamespaceNamespaceLister interface {
	// List lists all ImageNamespaces in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*business.ImageNamespace, err error)
	// Get retrieves the ImageNamespace from the indexer for a given namespace and name.
	Get(name string) (*business.ImageNamespace, error)
	ImageNamespaceNamespaceListerExpansion
}

// imageNamespaceNamespaceLister implements the ImageNamespaceNamespaceLister
// interface.
type imageNamespaceNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all ImageNamespaces in the indexer for a given namespace.
func (s imageNamespaceNamespaceLister) List(selector labels.Selector) (ret []*business.ImageNamespace, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*business.ImageNamespace))
	})
	return ret, err
}

// Get retrieves the ImageNamespace from the indexer for a given namespace and name.
func (s imageNamespaceNamespaceLister) Get(name string) (*business.ImageNamespace, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(business.Resource("imagenamespace"), name)
	}
	return obj.(*business.ImageNamespace), nil
}
