/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by lister-gen. DO NOT EDIT.

package internalversion

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	business "tkestack.io/tke/api/business"
)

// PlatformLister helps list Platforms.
type PlatformLister interface {
	// List lists all Platforms in the indexer.
	List(selector labels.Selector) (ret []*business.Platform, err error)
	// Get retrieves the Platform from the index for a given name.
	Get(name string) (*business.Platform, error)
	PlatformListerExpansion
}

// platformLister implements the PlatformLister interface.
type platformLister struct {
	indexer cache.Indexer
}

// NewPlatformLister returns a new PlatformLister.
func NewPlatformLister(indexer cache.Indexer) PlatformLister {
	return &platformLister{indexer: indexer}
}

// List lists all Platforms in the indexer.
func (s *platformLister) List(selector labels.Selector) (ret []*business.Platform, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*business.Platform))
	})
	return ret, err
}

// Get retrieves the Platform from the index for a given name.
func (s *platformLister) Get(name string) (*business.Platform, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(business.Resource("platform"), name)
	}
	return obj.(*business.Platform), nil
}
