/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1 "tkestack.io/tke/api/notify/v1"
)

// MessageLister helps list Messages.
type MessageLister interface {
	// List lists all Messages in the indexer.
	List(selector labels.Selector) (ret []*v1.Message, err error)
	// Get retrieves the Message from the index for a given name.
	Get(name string) (*v1.Message, error)
	MessageListerExpansion
}

// messageLister implements the MessageLister interface.
type messageLister struct {
	indexer cache.Indexer
}

// NewMessageLister returns a new MessageLister.
func NewMessageLister(indexer cache.Indexer) MessageLister {
	return &messageLister{indexer: indexer}
}

// List lists all Messages in the indexer.
func (s *messageLister) List(selector labels.Selector) (ret []*v1.Message, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.Message))
	})
	return ret, err
}

// Get retrieves the Message from the index for a given name.
func (s *messageLister) Get(name string) (*v1.Message, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("message"), name)
	}
	return obj.(*v1.Message), nil
}
